
-- we want to produce files containing a list of ideals
-- and a file containing the Betti tables of the corresponding ideals
restart
--initialization
loadPackage("RandomCurvesOverVerySmallFiniteFields")
g=9
p=3
numberOfExamples=500
kk=ZZ/p
T=kk[t_0..t_(g-1)]
--viewHelp
fileName="examples_g_"|toString(g)|"_char_"|toString(p)   
filePath="g"|toString(g)|"/"|fileName
------------------------------------------------------
-- computing the list of ideals
   try L=value get filePath else L={};
for i from #L to (numberOfExamples-1) do(
    	IC:=smoothCanonicalCurve(g,p)
-- the following isrelevant if we run multiple versions of this script at the same time	
	try L=value get filePath else L={};
       L=L|{IC};
       filePath<<replace("[{}]","",toString(L))<<close;)
-----------------------------------------------------------------------   
L=value get filePath ; 
numberOfExamples=#L
----------------------------------------------------------------------
-- In the next step we compute the Betti numbers
-- therefore one should start M2 via shell by 
-- "GC_INITIAL_HEAP_SIZE=90G emacs poduceExamples.m2"
-- since the new fast syzygy algorithm is leaking memory
BettiOutput="g"|toString(g)|"/"|"bettiTables_"|fileName
try (BettiL=value get BettiOutput)  else BettiL={};
for i from #BettiL to (numberOfExamples-1) do (
      BettiL=BettiL|{minimalBetti(L_i,DegreeLimit=>1)};
       BettiOutput<<toString(BettiL)<<close;)
   
   #BettiL
   tally BettiL
BettiL=value get BettiOutput




